## remmina 1.4.27%2Bdfsg

=== debian/changelog ===
remmina (1.4.27+dfsg-2) unstable; urgency=medium

  [ Jeremy Bicha ]
  * Temporarily stop building the spice plugin
    to prevent remmina from using libsoup2.4 &
    libsoup3 simultaneously (Closes: #1015147)
  * Add minimal debian/gbp.conf

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 29 Jul 2022 22:09:14 +0200

remmina (1.4.27+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/control: S-V bump 4.6.0 -> 4.6.1 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 24 Jun 2022 20:52:05 +0200

remmina (1.4.26+dfsg-1) experimental; urgency=medium

  * New upstream release
    - debian/: Python plugin support added

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 22 May 2022 21:14:19 +0200
