=== debian/changelog ===
remmina (1.4.27+dfsg-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Revert "Temporarily stop building the spice plugin"

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 17 Aug 2022 13:49:33 +0200
